{*************************************************************}
{*                Unit FaCrypt v1.0                          *}
{*    Copyright (c) 2000 by Dmitry Beloshistov [-=BDS=-]     *}
{*               Simple File crypter                         *}
{*************************************************************}

Unit FaCript;
{$F+,O+,G+}
Interface

 Function GenPassword(MaxLen:byte):String;
 Procedure GenKeyFile(MaxLen:Word;FileName:String);
 Procedure CriptFile_Psw(Psw,SourceFile,DestFile:String; CriptFlag:boolean);
 Procedure CriptFile_Key(SourceFile,DestFile,KeyFile:String; CriptFlag:boolean);

Implementation

Uses Objects,Strings,FManage;

const
     PswChars:TCharSet=[#33..#126];

type PBuffer=^TBuffer;
     TBuffer=array[0..65519] of Char;

Procedure SwapNible; assembler;
asm
   push bx
   push ax
   and al,0Fh
   mov bl,al
   pop ax
   and al,0F0h
   shl bl,4
   shr al,4
   or al,bl
   pop bx
end;

Procedure CriptArray(var Cript; var Buf1; Len:Word; CriptUnCript:boolean);
assembler;
asm
   push ds
   push es
   lds si,Buf1          {ds:si -> data buffer}
   les di,Cript         {es:di -> CriptBuffer}
   mov cx,Len           {cx -> lenght of buffer}
@@1:
   mov ax,word ptr ds:si
   mov bx,word ptr es:di
   cmp CriptUnCript,1
   jne @Un_Cript
   call SwapNible         {----------------- cript rountine}
   xchg al,ah
   call SwapNible
   xor ax,bx
   jmp @move_data
@un_cript:
   xor ax,bx            {----------------- uncript rountine}
   call SwapNible
   xchg al,ah
   call SwapNible
@move_data:
   mov word ptr ds:si,ax
   inc si
   inc si
   inc di
   inc di
   loop @@1
   pop es
   pop ds
end;

Function GenPassword(MaxLen:byte):String;
var S:String; ch:Char;
begin
 randomize;
 S:='';
 repeat
   Ch:=char(lo(random(127)));
   if ch in PswChars then S:=S+Ch;
 until length(s)>=MaxLen;
 S[0]:=Char(MaxLen);
GenPassword:=S;
end;

Procedure GenKeyFile(MaxLen:Word;FileName:String);
var Buffer:PBuffer;
    I:Word; Ch:Char;
    S:TBufStream;
begin
 randomize;
 Buffer:=New(PBuffer);
 if MaxLen>SizeOf(TBuffer) then MaxLen:=SizeOf(TBuffer);
 For I:=0 to MaxLen do
  begin
   repeat
    Ch:=char(lo(random(127)));
    if ch in PswChars then Buffer^[i]:=Ch;
   until Ch in PswChars;
  end;
 S.Init(FileName,stCreate,32728);
 if S.Status=stOk then
  begin S.Write(Buffer^,MaxLen); S.Done; end;
 Dispose(Buffer);
end;

Procedure FillPswBuffer(Psw:String; var Buffer:PBuffer);
var BCrp,CrpBuf:array[0..1023] of char;
    i:Word;
    L,L1:Word;
begin
 FillChar(Buffer^,SizeOf(TBuffer),#0);
 FillChar(CrpBuf,SizeOf(CrpBuf),#0);
 StrPCopy(BCrp,Psw);
 L:=SizeOf(CrpBuf) div StrLen(BCrp);
 L1:=SizeOf(CrpBuf) mod StrLen(BCrp);
 for i:=1 to L do StrCat(CrpBuf,BCrp);
 if L1>0 then
 begin
  i:=StrLen(CrpBuf);
  L:=StrLen(BCrp);
   For L1:=0 to L do
    begin
     inc(i);
     if i>=SizeOf(CrpBuf) then break;
     CrpBuf[i]:=BCrp[L1];
    end;
 end;
 L:=SizeOf(TBuffer) div StrLen(CrpBuf);
 L1:=SizeOf(TBuffer) mod StrLen(CrpBuf);
 for i:=1 to L do StrCat(Buffer^,CrpBuf);
 if L1>0 then
 begin
  i:=L*StrLen(CrpBuf);
  L:=StrLen(CrpBuf);
   For L1:=0 to L do
    begin
     inc(i);
     if i>=SizeOf(Tbuffer) then break;
     Buffer^[i]:=CrpBuf[L1];
    end;
 end;
end;

Procedure CriptFile_Key(SourceFile,DestFile,KeyFile:String; CriptFlag:boolean);
var CriptKey:PBuffer;
    Buffer:PBuffer;
    SIn,SOut:TBufStream;
    CriptLen:Word;
    Len:Word;
    Flag:boolean;
begin
 Sin.Init(KeyFile,stOpenRead,32728);
 if Sin.Status<>stOk then exit;
 CriptKey:=New(PBuffer);
 SIn.Read(CriptKey^,Sin.GetSize);
 CriptLen:=SIn.GetSize;
 SIn.Done;
 Sin.Init(SourceFile,stOpenRead,8192);
 if Sin.Status<>stOk then exit;
 SOut.Init(DestFile,stCreate,8192);
 if Sout.Status<>stOk then begin
                            Sin.Done;
                            exit;
                           end;
 Buffer:=New(PBuffer);
 repeat
  Flag:=((SIn.GetSize-SIn.GetPos)>=CriptLen);
  if Flag then Len:=CriptLen else Len:=Sin.GetSize-Sin.GetPos;
  SIn.Read(Buffer^,Len);
  CriptArray(CriptKey^,Buffer^,Len,CriptFlag);
  SOut.Write(Buffer^,Len);
 until SIn.GetPos>=SIn.GetSize;
 Dispose(Buffer);
 Dispose(CriptKey);
 Sin.Done;
 Sout.Done;
end;

Procedure DelBufKey;
var Buffer:PBuffer;
    S:TBufStream;
    Er:byte;
begin
 New(Buffer);
 S.Init('BufKey.$$$',stOpenWrite,32728);
 FillChar(Buffer^,SizeOf(TBuffer),#0);
 S.Seek(0);
 S.Write(Buffer^,SizeOf(TBuffer));
 S.Done;
 Dispose(Buffer);
 FDel('BufKey.$$$',Er);
End;

Procedure CriptFile_Psw(Psw,SourceFile,DestFile:String; CriptFlag:boolean);
var Buffer:PBuffer;
    SKey:TBufStream;
begin
 Buffer:=New(PBuffer);
 FillPswBuffer(Psw,Buffer);
 Skey.Init('BufKey.$$$',stCreate,32728);
 if SKey.Status<>stOk then begin
                             Dispose(Buffer);
                             exit;
                           end;
 SKey.Write(Buffer^,SizeOf(TBuffer));
 SKey.Done;
 Dispose(Buffer);
 CriptFile_Key(SourceFile,DestFile,'BufKey.$$$',CriptFlag);
 DelBufKey;
end;

end.
